<?php
if ( ! class_exists( 'Designer_Boutique_Shop_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Designer_Boutique_Shop_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Designer_Boutique_Shop_Plugin_Activation_WPElemento_Importer {

        private static $designer_boutique_shop_instance;
        public $designer_boutique_shop_action_count;
        public $designer_boutique_shop_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$designer_boutique_shop_instance) ) {
            self::$designer_boutique_shop_instance = new self();
          }
          return self::$designer_boutique_shop_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'designer_boutique_shop_recommended_plugins', array($this, 'designer_boutique_shop_recommended_elemento_importer_plugins_array') );

            $designer_boutique_shop_actions                   = $this->designer_boutique_shop_get_recommended_actions();
            $this->designer_boutique_shop_action_count        = $designer_boutique_shop_actions['count'];
            $this->designer_boutique_shop_recommended_actions = $designer_boutique_shop_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function designer_boutique_shop_recommended_elemento_importer_plugins_array($designer_boutique_shop_plugins){
            $designer_boutique_shop_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'designer-boutique-shop'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'designer-boutique-shop'),               
            );
            return $designer_boutique_shop_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'designer-boutique-shop-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('designer-boutique-shop-plugin-activation-script', 'designer_boutique_shop_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'designer-boutique-shop'),
                    'activating' => esc_html__('Activating', 'designer-boutique-shop'),
                    'error' => esc_html__('Error', 'designer-boutique-shop'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'designer-boutique-shop-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function designer_boutique_shop_get_recommended_actions() {

            $designer_boutique_shop_act_count  = 0;
            $designer_boutique_shop_actions_todo = get_option( 'recommending_actions', array());

            $designer_boutique_shop_plugins = $this->designer_boutique_shop_get_recommended_plugins();

            if ($designer_boutique_shop_plugins) {
                foreach ($designer_boutique_shop_plugins as $designer_boutique_shop_key => $designer_boutique_shop_plugin) {
                    $designer_boutique_shop_action = array();
                    if (!isset($designer_boutique_shop_plugin['slug'])) {
                        continue;
                    }

                    $designer_boutique_shop_action['id']   = 'install_' . $designer_boutique_shop_plugin['slug'];
                    $designer_boutique_shop_action['desc'] = '';
                    if (isset($designer_boutique_shop_plugin['desc'])) {
                        $designer_boutique_shop_action['desc'] = $designer_boutique_shop_plugin['desc'];
                    }

                    $designer_boutique_shop_action['name'] = '';
                    if (isset($designer_boutique_shop_plugin['name'])) {
                        $designer_boutique_shop_action['title'] = $designer_boutique_shop_plugin['name'];
                    }

                    $designer_boutique_shop_link_and_is_done  = $this->designer_boutique_shop_get_plugin_buttion($designer_boutique_shop_plugin['slug'], $designer_boutique_shop_plugin['name'], $designer_boutique_shop_plugin['function']);
                    $designer_boutique_shop_action['link']    = $designer_boutique_shop_link_and_is_done['button'];
                    $designer_boutique_shop_action['is_done'] = $designer_boutique_shop_link_and_is_done['done'];
                    if (!$designer_boutique_shop_action['is_done'] && (!isset($designer_boutique_shop_actions_todo[$designer_boutique_shop_action['id']]) || !$designer_boutique_shop_actions_todo[$designer_boutique_shop_action['id']])) {
                        $designer_boutique_shop_act_count++;
                    }
                    $designer_boutique_shop_recommended_actions[] = $designer_boutique_shop_action;
                    $designer_boutique_shop_actions_todo[]        = array('id' => $designer_boutique_shop_action['id'], 'watch' => true);
                }
                return array('count' => $designer_boutique_shop_act_count, 'actions' => $designer_boutique_shop_recommended_actions);
            }

        }

        public function designer_boutique_shop_get_recommended_plugins() {

            $designer_boutique_shop_plugins = apply_filters('designer_boutique_shop_recommended_plugins', array());
            return $designer_boutique_shop_plugins;
        }

        public function designer_boutique_shop_get_plugin_buttion($slug, $name, $function) {
                $designer_boutique_shop_is_done      = false;
                $designer_boutique_shop_button_html  = '';
                $designer_boutique_shop_is_installed = $this->is_plugin_installed($slug);
                $designer_boutique_shop_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $designer_boutique_shop_is_activeted = (class_exists($function)) ? true : false;
                if (!$designer_boutique_shop_is_installed) {
                    $designer_boutique_shop_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $designer_boutique_shop_plugin_install_url = wp_nonce_url($designer_boutique_shop_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $designer_boutique_shop_button_html        = sprintf('<a class="designer-boutique-shop-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($designer_boutique_shop_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'designer-boutique-shop'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'designer-boutique-shop')
                    );
                } elseif ($designer_boutique_shop_is_installed && !$designer_boutique_shop_is_activeted) {

                    $designer_boutique_shop_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($designer_boutique_shop_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $designer_boutique_shop_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $designer_boutique_shop_button_html = sprintf('<a class="designer-boutique-shop-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($designer_boutique_shop_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'designer-boutique-shop'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'designer-boutique-shop')
                    );
                } elseif ($designer_boutique_shop_is_activeted) {
                    $designer_boutique_shop_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'designer-boutique-shop'));
                    $designer_boutique_shop_is_done     = true;
                }

                return array('done' => $designer_boutique_shop_is_done, 'button' => $designer_boutique_shop_button_html);
            }
        public function is_plugin_installed($slug) {
            $designer_boutique_shop_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $designer_boutique_shop_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($designer_boutique_shop_installed_plugins[$designer_boutique_shop_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $designer_boutique_shop_keys = array_keys($this->get_installed_plugins());
            foreach ($designer_boutique_shop_keys as $designer_boutique_shop_key) {
                if (preg_match('|^' . $slug . '/|', $designer_boutique_shop_key)) {
                    return $designer_boutique_shop_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Designer_Boutique_Shop_Plugin_Activation_WPElemento_Importer::get_instance();